%include "main.inc"
%include "tinyfont.inc"


[GLOBAL print]

%if XRES == 320
    MSEP            equ     2

    MOSXRES         equ     6
    MOSYRES         equ     12
    
    MOS2XRES         equ     20
    MOS2YRES         equ     20
%endif

%if XRES == 800
    MSEP            equ     5
    MOSXRES         equ     15
    MOSYRES         equ     15
    
    MOS2XRES         equ    100
    MOS2YRES         equ     50
%endif

%if XRES == 1024
    MSEP            equ     6
    MOSXRES         equ     19
    MOSYRES         equ     19
    
    MOS2XRES         equ     128
    MOS2YRES         equ     64
%endif

%if XRES == 1920
    MSEP            equ     6
    MOSXRES         equ     19
    MOSYRES         equ     19
    
    MOS2XRES         equ     128
    MOS2YRES         equ     64
%endif

[SEGMENT .text USE32]

; eax: mos_buf
; esi: string
; edi: buffer
; ecx: alpha
print:
    pushad

        mov     edx, esi
        mov     esi, eax

        cmp     byte [edx], 1
        jne peque
            add     esi, 256*4
            inc     edx
            mov     ebp, (0<<24)+(MSEP<<16)+(MOS2YRES<<8)+MOS2XRES
            jmp     sigue
        peque:
        mov         ebp, (0<<24)+(MSEP<<16)+(MOSYRES<<8)+MOSXRES


        cmp byte [edx], 13
        jne sigue
        add edi, XRES*4*MOSYRES*2

   sigue:
        shl     ecx, 24
        or      ecx, ebp
        call    drawtext
        popad
        ret
