%include "main.inc"
%include "mlib.inc"
%include "ray_ker.inc"
%include "ray_bola.inc"


[GLOBAL escena_do]

; iqiq
[GLOBAL escena1]
[GLOBAL escena2]
[GLOBAL escena3]


[SEGMENT .data USE32]


; F(x,y,z) = 0 = a·x² + 2b·xy + 2d·x +
;                e·y² + 2f·yz + 2g·y +
;                h·z² + 2c·xz + 2i·z + j
;
; a, e, h,   d, g, i,    j
;
;
;
; esferoide : A(x-xc)² + B(y-yc)² + C(z-zc)² - r² = 0
;
;             A, B, C,    -A·xc, -B·yc, -C·zc,    A·xc²+B·yc²+C·zc²-r²
;
;
escena1:
    db  6

    dd  -1.0, -1.0, -1.0,   0.0, 0.0,  0.0,    22500.0
    db  0
    dd  1.0, 100.0, 1.0,   0.0, 0.0,  0.0,    -4000.0
    db  1
    dd  1.0, 0.0, 1.0,    50.0, 0.0,  00.0,    2480.0
    db  0
    dd  1.0, 0.0, 1.0,   -50.0, 0.0,  00.0,    2480.0
    db  0
    dd  1.0, 0.0, 1.0,     0.0, 0.0,  50.0,    2480.0
    db  0
    dd  1.0, 0.0, 1.0,     0.0, 0.0, -50.0,    2480.0
    db  0

    ;    CUADRIC  < -1.0, -1.0, -1.0,   0.0, 0.0,  0.0,    22500.0,  0 >
    ;    CUADRIC  <  1.0, 100.0, 1.0,   0.0, 0.0,  0.0,    -4000.0,  4 >
    ;    CUADRIC  <  1.0, 0.0, 1.0,    50.0, 0.0,  00.0,    2480.0,  0 >
    ;    CUADRIC  <  1.0, 0.0, 1.0,   -50.0, 0.0,  00.0,    2480.0,  0 >
    ;    CUADRIC  <  1.0, 0.0, 1.0,     0.0, 0.0,  50.0,    2480.0,  0 >
    ;    CUADRIC  <  1.0, 0.0, 1.0,     0.0, 0.0, -50.0,    2480.0,  0 >

escena2 db  3

    dd   -1.0, -1.0, -1.0,    0.0, 0.0, 0.0,     14400.0
    db    1
    dd    1.0, -1.0,  1.0,    0.0, 0.0, 0.0,       400.0
    db    0
    dd    10.0,  1.0, 10.0,   0.0, 0.0, 0.0,      -400.0
    db    2

    ;    CUADRIC  < -1.0, -1.0, -1.0,    0.0, 0.0, 0.0,     14400.0,  4 >
    ;    CUADRIC  <  1.0, -1.0,  1.0,    0.0, 0.0, 0.0,       400.0,  0 >
    ;    CUADRIC  <  10.0,  1.0, 10.0,   0.0, 0.0, 0.0,      -400.0,  8 >



escena3 db  3

   dd  -0.1, -1.0, -1.0,    0.0, 0.0, 0.0,   22500.0
   db  2
   dd  1.0,  60.0, 1.0,    0.0, 0.0, 0.0,    -900.0
   db  1
   dd  1.0,  0.0,  1.0,    0.0, 0.0, 0.0,     -25.0
   db  0

   ;     CUADRIC  < -0.1, -1.0, -1.0,    0.0, 0.0, 0.0,   22500.0,  8 >
   ;     CUADRIC  <  1.0,  60.0, 1.0,    0.0, 0.0, 0.0,    -900.0,  4 >
   ;     CUADRIC  <  1.0,  0.0,  1.0,    0.0, 0.0, 0.0,     -25.0,  0 >


lissa1  dd  0.0005        ; fr
        dd  0.1         ; of
        dd  100.0       ; amp

        dd  0.00028     ; fr
        dd  0.0         ; of
        dd  50.0        ; amp

        dd  0.00048     ; fr
        dd  1.57        ; of
        dd  100.0       ; amp



[SEGMENT .text USE32]

; eax : time
escena_do:
    pushad
    mov     edi, campos
    mov     esi, lissa1
    call    Lissa

    ; iqiqiqiq
    %if 1
    mov     edi, camtarget
    fldz
    fst     dword [edi+0]
    fst     dword [edi+4]
    fstp    dword [edi+8]
    %endif

    %if 0
    mov     edi, luz
    mov     esi, lissa2
    call    Lissa
    %endif

    popad
    ret
