;----------------------------------------------------------------------------;
;                                                                            ;
;                             Fades 32 bpp                                   ;
;                       para intros de 4k (PMode)                            ;
;                                                                            ;
;                              by iq/glue                                    ;
;                                                                            ;
;----------------------------------------------------------------------------;

%include "main.inc"

[GLOBAL fade]


[SEGMENT .text USE32]

; esi : buf1
; edx : buf2
; edi : buf
; eax : alpha
; ecx : tamao

fade:

    pushad
    push    eax
    mov     ebp, edx

    @loopFade:
        mov edx, [ebp]
        sub eax, eax
        mov ebx, [esi]
        mov al, dh
        mov dh, 0
        mov ah, bh
        mov bh, 0
        add ebp, 4
        sub edx, ebx
        add esi, 4
        imul edx, dword [esp]
        shr edx, 8
        add edx, ebx
        sub ebx, ebx
        mov bl, ah
        mov ah, 0
        sub eax, ebx

        imul eax, dword [esp]
        shl ebx, 8
        mov dh, 0
        add eax, ebx
        mov al, 0
        add eax, edx

        %if FAST==1
            mov [edi],eax
            add edi,4
            dec ecx
            jnz @loopFade
        %else
            stosd
            loop @loopFade
        %endif

    pop eax
    popad
    ret
