
%include "intro.inc"
%include "main.inc"

;----------------------------------------------------------------------------
[SEGMENT .data USE32]

bmi:    dd      40
        dd      XRES
        dd      -YRES
        dw      1
        dw      32
        dd      0
        dd      0
        dd      0
        dd      0
        dd      0
        dd      0
        db      0, 0, 0, 0

tto     dd      0

classname db 'STATIC', 0

%if 0
Library1  db "USER32"
Library2  db "GDI32"
funcs:
    db 'ChangeDisplaySettings', 0
    db 'CreateWindowEx', 0
    db 'PeekMessage', 0
    db 'ShowCursor', 0
    ;----
    db 'StretchDIBits', 0
    db 'GetDC', 0
%endif

;----------------------------------------------------------------------------
[SEGMENT .bss USE32]

buffer  RESD    XRES*YRES
devmode RESB    148
msg     RESB    56
hdc     RESD    1



;----------------------------------------------------------------------------
[SEGMENT .text USE32]
[GLOBAL _entrypoint]

%if 1
EXTERN _ChangeDisplaySettingsA@8 

EXTERN _ShowCursor@4

EXTERN _CreateWindowExA@48

EXTERN _PeekMessageA@20

EXTERN _GetDC@4

EXTERN _StretchDIBits@52
%else
[EXTERN __imp__LoadLibraryA@4]
[EXTERN __imp__GetProcAddress@8]

%endif

_entrypoint:

    ;--------------------------------------------------------
    %if 0
    
    push    dword Library1
    call    [__imp__LoadLibraryA@4]
    push    edi
    push    eax
    call    [__imp__GetProcAddress@8]
    mov     [edi], eax


    %endif

    ;--------------------------------------------------------

    push    dword 4
    mov     esi, devmode
    mov     [esi+ 36], word  148
    mov     [esi+ 40], dword 1835008
    mov     [esi+104], dword 32
    mov     [esi+108], dword XRES
    mov     [esi+112], dword YRES
    push    esi
    call     _ChangeDisplaySettingsA@8

    @l1:
        push    dword 0
        call    _ShowCursor@4
        test    eax, eax
        jge     @l1

    ;--------------------------------------------------------

    xor     eax, eax
    push    eax
    push    eax
    push    eax
    push    eax
    push    dword YRES
    push    dword XRES
    push    eax
    push    eax
    push    dword 0x96000000
    push    eax
    push    dword classname
    push    8
    call    _CreateWindowExA@48
    ;mov     [hWnd], eax

    push    eax
    call    _GetDC@4
    mov     [hdc], eax

    call    _intro_init


    @mainloop:

        xor     eax, eax
        mov     esi, msg
        push    1
        push    eax
        push    eax
        push    eax
        push    esi
        call    _PeekMessageA@20
        cmp     word [esi+4], 0x0100
        jz      acaba


        mov     eax, [tto]
        or      eax, eax
        %if P6
        cmovz   eax, [esi+16]
        mov     [tto], eax
        %else
        jnz     nofirstframe
        mov     eax, [esi+16]
        mov     [tto], eax
        nofirstframe:
        %endif


        mov     ebx, [esi+16]
        sub     ebx, eax

        push    ebx
        push    dword buffer
        call    _intro_do
        pop     ebx
        pop     ebx
        or      eax, eax
        jnz     acaba



        xor     eax, eax
        push    dword 0x00CC0020
        push    eax
        push    dword bmi
        push    dword buffer
        push    dword YRES
        push    dword XRES
        push    eax
        push    eax
        push    dword YRES
        push    dword XRES
        push    eax
        push    eax
        push    dword [hdc]
        call    _StretchDIBits@52

        jmp      @mainloop

    acaba:


    xor     eax, eax
    push    eax
    push    eax
    call     _ChangeDisplaySettingsA@8

    @l2:
        push    1
        call    _ShowCursor@4
        test    eax, eax
        jl      @l2

    ret
