; 178 bytes!!!!!!!!!


%include "mlib.inc"


[GLOBAL PLASMA_Hace256]



[SEGMENT .text USE32]



;-----------------------------------------------------------------------------
%define VAR_PA  (ebp+0)
%define VAR_PB  (ebp+4)
%define VAR_PC  (ebp+8)
%define VAR_PD  (ebp+12)
%define VAR_K   (ebp+16)
%define VAR_K2  (ebp+20)
%define VAR_P2  (ebp+20)


; eax = edx + (rand()&k)-P2);
; (bh,bl) = (j,i)
rasam:
    shr     edx, 1

    ;call    Random              ; !!!!!
    mov             eax, [mirand]
    imul            eax, 015a4e35h
    inc             eax
    mov             [mirand], eax
    shr             eax, 16


    and     eax, [VAR_K]
    sub     eax, [VAR_K2]
    add     eax, edx

    mov     ebx, edi
    ret


PoneVals:
    pushad

    mov     edi, ebx        ; edi = [[j][i]]

    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

    ; coge pa, pb, pc, pd


    movzx   eax, byte [esi+ebx]
    mov     [VAR_PA], eax

    add     bh, dl
    mov     al, [esi+ebx]
    mov     [VAR_PB], eax

    add     bl, dl
    mov     al, [esi+ebx]
    mov     [VAR_PD], eax

    sub     bh, dl
    mov     al, [esi+ebx]
    mov     [VAR_PC], eax

    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


    mov      edx, [VAR_PA]
    add      edx, [VAR_PC]
    call     rasam
    add      bl, [VAR_P2]
    mov      [esi+ebx], al
    ;;;;;;
    mov      edx, [VAR_PA]
    add      edx, [VAR_PB]
    call     rasam
    add      bh, [VAR_P2]
    mov      [esi+ebx], al
    ;;;;;;
    mov      edx, [VAR_PA]
    add      edx, [VAR_PB]
    add      edx, [VAR_PC]
    add      edx, [VAR_PD]
    shr      edx, 1
    call     rasam
    mov      dl, [VAR_P2]
    add      bl, dl
    add      bh, dl
   
    mov      [esi+ebx], al

    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

    popad
    ret



; en esi
PLASMA_Hace256:
    pushad
    pushad              ; vars.locales
    mov     ebp, esp    ; vars.locales




    mov     byte [esi], 127
    
    xor     ecx, ecx
    mov     cl, 8               ; mov     ecx, 8
    @loopPP:
        xor     edx, edx
        inc     edx             ; mov     edx, 1
        shl     edx, cl

        mov     eax, edx
        shr     eax, 1
        mov     [VAR_K2], eax

        shl     eax, 1
        dec     eax
        mov     [VAR_K], eax


        
        xor ebx, ebx
        @loopI:
            @loopJ:
                call    PoneVals
            add bl, dl
            jnz @loopJ
        add bh, dl
        jnz @loopI


    loop    @loopPP

    popad
    popad

    ;call    Soften256

    ret


%if 0
; esi
Soften256:
    pushad

    xor     dl, dl
    xor     ebx, ebx

    mov     ecx, 256*256
    loopSOF:
        dec     bl
        movzx   eax, byte [esi+ebx]
        inc     bl
        dec     bh
        add     al, [esi+ebx]
        adc     ah, dl ; 0
        add     bh, 2
        add     al, [esi+ebx]
        adc     ah, dl ; 0
        dec     bh
        inc     bl
        add     al, [esi+ebx]
        adc     ah, dl ; 0
        shr     eax, 2
        mov     [esi+ebx], al
    loop    loopSOF

    popad
    ret
%endif
