%include "main.inc"
%include "mmath.inc"
%include "mlib.inc"
%include "ray_ker.inc"
%include "ray_cam.inc"
%include "ray_scn.inc"


; iqiqiq
EXTERN raybuf

[GLOBAL RAY_DoFrame]
[GLOBAL dir]

;iqiq
EXTERN incx
EXTERN incy
EXTERN vecy

[SEGMENT .bss USE32]

dir         RESD 3
;inter       RESD 3
;normal      RESD 3
;v           RESD 3

vecx        RESD 3
;vecy        RESD 3
;incx        RESD 3
;incy        RESD 3

[SEGMENT .text USE32]

; pinta en edi
RAY_DoFrame:

    mov edx, [rptr] ; if( !ptr ) return;
    or  edx, edx
    jnz pinta
;pushad
;popad
    ret

    ; mueve luces y tal
pinta:
    call    escena_do

    ; renderiza


    pushad

    call    RAY_CalcCamera
    
    mov     edi, raybuf


    mov     ebp, edi


    mov     ebx, YRES
    @RLoopY:

        mov     esi, vecy
        mov     edi, vecx
        call    MATH_VecCopy        ; vecx = vecy

        mov     edx, XRES
        @RLoopX:

            ;mov     esi, vecx
            mov     esi, edi        ; tb abajo edi=vecx!
            mov     edi, dir
            call    MATH_VecCopy

            call    echa_rayo

            mov     [ebp], eax
            add     ebp, 4

            ;
            mov     edi, vecx
            mov     esi, incx
            call    MATH_VecAdd2     ; vecx += incx

        dec     edx
        jnz     @RLoopX

        ;
        mov     edi, vecy
        mov     esi, incy
        call    MATH_VecAdd2         ; vecy += incy

    dec     ebx
    jnz     @RLoopY

    popad
    ret
