;▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒
;Kindergarden, interfaz para mosaico           (c) 2000/01 Geiger/Centosis^Glue
;▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒


%include "main.inc"
%include "font.inc"

[GLOBAL createmos]
[GLOBAL drawtext]

[SEGMENT .bss USE32]

temp_filler RESD 1

[SEGMENT .text USE32]

;░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░
;escribir una frase

;edi - video buffer
;esi - font offsets
;edx - asciiz text
;eax - posx
;ebx - posy
;ecx - [intensidad | espaciado entre letras | tamy | tamx] (8 bits cada campo)

drawtext:
    mov ebp,edx
    xor edx,edx
drawtextlp:
    mov dl,[ebp]
    test dl,dl
    jz endrawtext

    ;cmp dl, 13
    ;jne sigue2
    ;add edi, XRES*4*MOSYRES*2
    ;sigue2:

    pushad
    mov esi,[esi+edx*4]
    test esi,esi                ;comprobacion de puntero nulo
    jz noexist                  ;(se puede eliminar)
		
    xor edx,edx
    mov ebp,ecx
    mov dl,ch
    shr ebp,24
    and ecx,255
    call spriteadd
	
noexist:
    popad
                            %if 0
    mov edx,ecx
    shr edx,16
    xor dh,dh
    add dl,cl
    adc dh,0
    add eax,edx
                            %else
    mov edx,ecx
    shr edx,16
    xor dh,dh
    add dl,cl
    adc dh,0
    shl edx, 2
    add edi,edx
                             %endif
    inc ebp
    jmp drawtextlp
endrawtext:
    ret

;░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░
;putsprite, suma 8-32 :: usa las macros XRES,YRES para clipping

;edi - destino
;esi - origen
;eax - posx
;ebx - posy
;ecx - tamx
;edx - tamy
;ebp - intensidad (0..255)

spriteadd:
    push ebp
    push ecx
    push ecx
    push edx
%if 0
    mov ebp,ebx
    imul ebp,XRES*4
    add edi,ebp
    lea edi,[edi+eax*4]
%endif
    ;for(;tamy>0;tamy--){memcpy(destino,txt,tamx);destino+=l_320;txt+=x;}
    add esi,ecx
    lea edi,[edi+ecx*4]

    xor ebx,ebx
    mov bl,[esp+12]
sploopery:
    xor ebp,ebp
    sub ebp,[esp+4]
splooperx:
    mov al,[esi+ebp]
    mov ecx,[edi+ebp*4]
    mul bl
    mov al,ah
    and ecx,00fefeffh
    shl eax,8
    mov edx,01010100h
    mov al,ah
    and eax,00fefeffh
    add eax,ecx
    mov ecx,80808000h
    and edx,eax
    sub ecx,edx
    shr ecx,7
    or eax,ecx
    mov [edi+ebp*4],eax

    inc ebp
    jnz splooperx

    add edi,XRES*4
    add esi,[esp+8]
    dec dword [esp]
    jnz sploopery

    add esp,4*4

    ret

;░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░
;auxiliares para la linea y arcos

lefttoright:
    ;if (x0>x1){x=x0;x0=x1;x1=x;y=y0;y0=y1;y1=y;}
    cmp eax,ecx
    jle nox0x1
    xchg eax,ecx
    xchg ebx,edx
nox0x1:
    ret

;░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░
;linea, 8bpp, color fijo, generico

;edi - destino
;esi - xres
;eax - x0
;ebx - y0
;ecx - x1
;edx - y1

COLOR_LINEA   equ   255

linea:
    call lefttoright
        ;ptr=p->ptr+x0+y0*xres;
        ;ptrd=p->ptr+x1+y1*xres;
        ;if (y1<=y0) xres=-xres;
    mov ebp,edx
    imul ebp,esi
    add ebp,ecx
    add ebp,edi
    push ebp
    mov ebp,ebx
    imul ebp,esi
    add ebp,eax
    add edi,ebp
    cmp edx,ebx
    jg noy1y0
        neg esi
noy1y0:
        ;x=x0;y=y0;dx=x1-x0;dy=abs(y0-y1);
    sub ecx,eax
    sub edx,ebx
    mov ebp,edx
    sar ebp,31
    xor edx,ebp
    sub edx,ebp
        ;if (dy<dx){incrE=2*dy;d=incrE-dx;incrNE=d-dx;add1=1;add2=xres;}
        ;else{   incrE=2*dx;d=incrE-dy;incrNE=d-dy;add1=xres;add2=1;}
    cmp edx,ecx
    jge nodydx
    lea eax,[edx*2]
    mov ebp,eax
    sub ebp,ecx
    mov ebx,ebp
    sub ebx,ecx
    mov ecx,1
    mov edx,esi
    jmp dydx
nodydx:
    lea eax,[ecx*2]
    mov ebp,eax
    sub ebp,edx
    mov ebx,ebp
    sub ebx,edx
    mov ecx,esi
    mov edx,1
dydx:
        ;*ptr=255;
        ;while (ptr!=ptrd){
        ;     if (d<=0){d=d+incrE ;ptr+=add1;}
        ;     else   {d=d+incrNE;ptr+=add1;ptr+=add2;}
        ;     *ptr=255;
    mov [edi],byte COLOR_LINEA
    cmp edi,[esp]
    je linearet
    add edi,ecx
    cmp ebp,0
    jg d01
    add ebp,eax
    jmp dydx
d01:
    add ebp,ebx
    add edi,edx
    jmp dydx
linearet:
    pop eax
    ret

;░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░
;rutina auxiliar para arcos

COLOR_ARCOS   equ   255

;edi - destino
;esi - xres
;ebp - addx
;eax - x0
;ebx - y0
;ecx - a (radio x)
;edx - b (radio y)

arc_putpixel:
                        ;STACK=ret deltax deltay x y xres addx
    mov esi,[esp+12+4]
    imul esi,[esp+16+4]
    add esi,[esp+8+4]
    mov [edi+esi], byte COLOR_ARCOS
    ret
endp

arcgen:                 ;STACK
    push ebp            ;addx
    push esi            ;xres addx
                        ;ptr+=x0+y0*abs(xres);
    add edi,eax
    imul ebx,esi
    mov eax,ebx
    sar eax,31
    xor ebx,eax
    sub ebx,eax
    add edi,ebx
                        ;a2=a*a;b2=b*b;
    mov eax,ecx
    imul ecx,ecx
    mov ebx,edx
    imul edx,edx
                        ;deltaE=b2*3;
    lea esi,[edx+edx*2]
    push esi            ;deltaE xres addx
                        ;deltaSE=deltaE+a2*(-2*b+2);
    xor ebp,ebp
    sub ebp,ebx
    lea ebp,[ebp*2+2]
    imul ebp,ecx
    add esi,ebp         ;deltaSE deltaE xres addx
    push esi
                        ;deltay=a2*(2*b-1)/2;
    lea esi,[ebx*2-1]
    imul esi,ecx
    sar esi,1
    push esi            ;deltay deltaSE deltaE xres addx
                        ;deltax=b2;
    push edx            ;deltax deltay deltaSE deltaE xres addx
                        ;d=b2-a2*b+a2/4;
    mov ebp,ecx
    mov esi,ecx
    sar ebp,2
    imul esi,ebx
    sub ebp,esi
    add ebp,edx
                        ;x=0;y=b;
    xor eax,eax
    xchg eax,[esp+8]    ;deltax deltay x deltaE xres addx
    xchg ebx,[esp+12]   ;deltax deltay x y xres addx
                        ;ptr[xres*y]=255;
    call arc_putpixel
                        ;while (deltay>deltax){
                        ;     if (d<0){d+=deltaE ;deltaSE+=2*b2;}
                        ;     else  {d+=deltaSE;deltaSE+=2*b2+2*a2;y--;deltay-=a2;}
                        ;     deltaE+=2*b2;x+=addx;deltax+=b2;
                        ;     ptr[xres*y+x]=255;
alooper1:
    mov esi,[esp+4]
    cmp esi,[esp]
    jle outalooper1
        cmp ebp,0
        jge noad0
            add ebp,ebx
            lea eax,[eax+edx*2]
            jmp nextlooper1
noad0:
            add ebp,eax
            lea eax,[eax+edx*2]
            lea eax,[eax+ecx*2]
            dec dword [esp+12]
            sub [esp+4],ecx
nextlooper1:
        lea ebx,[ebx+edx*2]
        mov esi,[esp+20]
        add [esp+8],esi
        add [esp],edx
        call arc_putpixel
        jmp alooper1
outalooper1:
                        ;d=b2*((2*(x*addx)+1)*(2*(x*addx)+1)/4)+a2*((y-1)*(y-1)-b2);
    mov ebp,[esp+8]
    imul ebp,[esp+20]
    lea ebp,[ebp*2+1]
    imul ebp,ebp
    sar ebp,2
    imul ebp,edx
    mov esi,[esp+12]
    dec esi
    imul esi,esi
    sub esi,edx
    imul esi,ecx
    add ebp,esi
                        ;deltaS=a2*(-2*y+3);
    mov ebx,[esp+12]
    neg ebx
    lea ebx,[ebx*2+3]
    imul ebx,ecx
                        ;a2*=2;
    shl ecx,1
                        ;while (y>0){
                        ; if (d<0){d+=deltaSE;deltaSE+=a2+2*b2;x+=addx;}
                        ; else  {d+=deltaS ;deltaSE+=a2;}
                        ; deltaS+=a2;y--;
                        ; ptr[xres*y+x]=255;
looper2:
    cmp dword [esp+12],0
    jle endlooper2
        cmp ebp,0
        jge nobd0
            add ebp,eax
            add eax,ecx
            lea eax,[eax+edx*2]
            mov esi,[esp+20]
            add [esp+8],esi
            jmp nextlooper2
nobd0:
            add ebp,ebx
            add eax,ecx
nextlooper2:
        add ebx,ecx
        dec dword [esp+12]
        call arc_putpixel
        jmp looper2
endlooper2:
    add esp,24
    ret

;░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░
;arco concavo, 8bpp, generico

;edi - destino
;esi - xres
;eax - x0
;ebx - y0
;ecx - x1
;edx - y1

arcup:
    call lefttoright
                ;if (y0<y1) mosellipse(p->ptr,x0,y1,x1-x0,y1-y0,-p->xres, 1);
                ;else    mosellipse(p->ptr,x1,y0,x1-x0,y0-y1,-p->xres,-1);
    neg esi
    cmp ebx,edx
    jge upy0y1
        xchg ebx,edx
        sub edx,ebx
        neg edx
        sub ecx,eax
        mov ebp,1
        call arcgen
        ret
upy0y1:
        xchg eax,ecx
        sub ecx,eax
        neg ecx
        sub edx,ebx
        neg edx
        mov ebp,-1
        call arcgen
        ret

;░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░
;arco convexo, 8bpp, generico

;edi - destino
;esi - xres
;eax - x0
;ebx - y0
;ecx - x1
;edx - y1

arcdown:
    call lefttoright
                ;if (y0<y1) mosellipse(p->ptr,x1,y0,x1-x0,y1-y0, p->xres,-1);
                ;else    mosellipse(p->ptr,x0,y1,x1-x0,y0-y1, p->xres, 1);
    cmp ebx,edx
    jge downy0y1
        xchg eax,ecx
        sub ecx,eax
        neg ecx
        sub edx,ebx
        mov ebp,-1
        call arcgen
        ret
downy0y1:
        xchg ebx,edx
        sub ecx,eax
        sub edx,ebx
        mov ebp,1
        call arcgen
        ret

;░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░
;Auxiliar para el flood filler

floodaux2:
    mov al,[esi+ecx]
    test al,al
    je fla1
        mov [edi+ecx],ah
fla1:
    ret

floodaux:
                ;if (y<yres-1 && dp[xres+x]!=0)   op[xres+x]=255;
                ;if (       dp[x]!=0)     op[x]=255;
                ;if (y>0   && dp[-xres+x]!=0)  op[-xres+x]=255;
    call floodaux2
    sub ecx,ebp
    cmp edx,0
    jle fla3
    call floodaux2
fla3:
    lea ecx,[ecx+ebp*2]
    dec ebx
    cmp edx,ebx
    jge fla4
    call floodaux2
fla4:
    inc ebx
    sub ecx,ebp
    ret


;░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░
;Floodfiller para mosaico, generico

;esi - origen
;edi - destino
;eax - xres
;ebx - yres
;ecx - x
;edx - y

COLOR_FILL   equ   255

floodfill:
    mov ebp,eax
                ;char *dp=or->ptr+y*xres;
                ;char *op=dest->ptr+y*xres;
    imul eax,edx
    add esi,eax
    add edi,eax

    mov ah,COLOR_FILL
                ;while (x<xres && dp[x]==0) x++;
fllp1:
    cmp ecx,ebp
    jge flend1
    mov al,[esi+ecx]
    test al,al
    jne flend1
        inc ecx
        jmp fllp1
flend1:
                ;if (x<xres){
                ;     if (y<yres-1 && dp[xres+x]!=0)   op[xres+x]=255;
                ;     if (       dp[x]!=0)     op[x]=255;
                ;     if (y>0   && dp[-xres+x]!=0)  op[-xres+x]=255;
                ;}
    cmp ecx,ebp
    jge fl2
    call floodaux
fl2:
                ;x--;int savex=x;
                ;for (;x>=0 && dp[x]==0;x--) op[x]=255;
    dec ecx
    push ecx
fllp3:
    cmp ecx,0
    jl flend3
    mov al,[esi+ecx]
    test al,al
    jne flend3
        mov [edi+ecx],ah
        dec ecx
        jmp fllp3
flend3:
                ;if (x>=0){
                ;     if (y<yres-1 && dp[xres+x]!=0)  op[xres+x]=255;
                ;     if (       dp[x]!=0)    op[x]=255;
                ;     if (y>0   && dp[-xres+x]!=0) op[-xres+x]=255;
    cmp ecx,0
    jl fl22
    call floodaux
fl22:
                ;for (x=savex;x>=0 && dp[x]==0;x--){
                ;     if (y<yres-1){
                ;         if (dp[xres+x]!=0) op[xres+x]=255;
                ;         if (dp[xres+x]==0 && op[xres+x]==0) mos_fill(dest,or,x,y+1);
                ;     }
                ;     if (y>0){
                ;         if (dp[-xres+x]!=0) op[-xres+x]=255;
                ;         if (dp[-xres+x]==0 && op[-xres+x]==0) mos_fill(dest,or,x,y-1);
    pop ecx
    xor al,al
fllp4:
    cmp ecx,0
    jl flend4
    cmp al,[esi+ecx]
    jne flend4
        push ebx
        dec ebx
        cmp edx,ebx
        pop ebx
        jge lp552
        mov dword [temp_filler],1

        call recurs_down
lp552:
        cmp edx,0
        jle lp772
        mov dword [temp_filler],-1
        call recurs_up
lp772:
        dec ecx
        jmp fllp4
flend4:
    ret

;░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░
;auxiliar para floodfiller


recurs_down:
    push ecx
    add ecx,ebp
    jmp nextrecurs
recurs_up:
    push ecx
    sub ecx,ebp
nextrecurs:
    cmp al,[esi+ecx]
    je lp44
        mov [edi+ecx],ah
lp44:
		cmp al,[esi+ecx]
		jne lp55
		cmp al,[edi+ecx]
		jne lp55
			pop ecx
			pushad
			mov eax,edx
			imul eax,ebp
			sub esi,eax
			sub edi,eax
			mov eax,ebp
			add edx,dword [temp_filler]
			call floodfill
			popad
			ret
lp55:
        pop ecx
        ret


;░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░
;Downsampling (box), 8bpp

;edi - destino
;esi - origen
;eax - xres
;ebx - yres
;cl  - factor de downsampling (log2)

downsample:
    mov edx,1
    shl edx,cl
    mov ch,dl
    sub eax,edx
    push eax    ;STACK: (xres-dx)
    add eax,edx
    mov ebp,1
    sub ebp,eax
    imul ebp,edx
    push ebp    ;STACK: (dx-dx*xres) (xres-dx)
    mov ebp,edx
    dec ebp
    imul ebp,eax
    push ebp    ;STACK: ((dx-1)*xres) (dx-dx*xres) (xres-dx)
    shr ebx,cl
    shr eax,cl
    push ebx    ;STACK: yres2 ((dx-1)*xres) (dx-dx*xres) (xres-dx)
    push eax    ;STACK: xres2 yres2 ((dx-1)*xres) (dx-dx*xres) (xres-dx)

            ;for (j=0;j<dest->yres;j++,o+=(dx-1)*or->xres)
            ;for (i=0;i<dest->xres;i++,d++,o+=dx-dx*or->xres){
            ;     k=0;
            ;     for(y=0;y<dx;y++,o+=or->xres-dx)
            ;     for(x=0;x<dx;x++,o++)
            ;         k+=*o;
            ;     *d=k>>div;
    xor ebx,ebx
    add cl,cl
lpy0:
     mov ebp,[esp]
lpx0:
      xor eax,eax
      mov dh,ch
lpy1:
       mov dl,ch
lpx1:
        mov bl,[esi]
        inc esi
        add eax,ebx
        dec dl
        jnz lpx1

       add esi,[esp+16]
       dec dh
       jnz lpy1

      shr eax,cl
      mov [edi],al

     add esi,[esp+12]
     inc edi
     dec ebp
     jnz lpx0

    add esi,[esp+8]
                dec dword [esp+4]
    jnz lpy0

    add esp,20
    ret

;░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░
;auxiliares para la creacion del mosaico

createmosaux2:
    add cl,[esi]      ;multiplicar valores en coma fija 0.8 por xres,yres
    adc ch,0
    add cl,[esi]
    adc ch,0
    mov cl,[edx+ecx]
    xor ch,ch
    inc cl
    jz cm2trick       ;para perdida de precision en coma fija con tamaños de letra grandes
        dec cl
        imul ecx,eax
        shr ecx,8
        ret
cm2trick:
        mov ecx,eax
        dec ecx
        ret

createmosaux:
;edx - dot ptr
;eax - xres
;ebx - yres
;esi - ptr
;ebp - function

cauxlp:
    cmp [esi],byte 255
    je cauxend

        push ebp
        mov ebp,4
cauxlp2:
        mov ecx,ebp
        and ecx,1
        call createmosaux2
        push ecx
        mov ecx,ebp
        and ecx,1
        add esi,ecx
        xchg eax,ebx
        dec ebp
        jnz cauxlp2
        mov ebp,[esp+16]

        pushad
        mov esi,eax
        mov eax,[esp+12+8*4]
        mov ebx,[esp+8 +8*4]
        mov ecx,[esp+4 +8*4]
        mov edx,[esp+0 +8*4]
        call ebp
        popad

        add esp,5*4
        jmp cauxlp
cauxend:
        inc esi
        ret

createmosauxskip:
        xor ecx,ecx
        mov cl,[esi]
        inc esi
        mov edx,esi           ;edx - puntero a vertices
        lea esi,[esi+ecx*2]   ;esi - puntero a lineas
        ret

;░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░
;crear mosaico

;esi - definicion de mosaico
;al  - xres final (sin supersampling)
;ah  - yres final (sin supersampling)
;edi - buffer temporal          (xres*yres*2 shl supersampling*2)
;ecx - factor supersampling, log2
;ebx - buffer fuente      (xres*yres*numero de letras)
;edx - tabla offsets      (256*4)

createmos:
    push ecx
    push ebx
    push edx
                            ;---primero creamos el mosaico---
    xor ebx,ebx
    mov bl,ah
    and eax,255
    shl eax,cl              ;xres*supersampling
    shl ebx,cl              ;yres*supersampling

	pushad                  ;clear (eliminar si solo se va a generar 1 mosaico)
	mov ecx,eax
	imul ecx,ebx
	xor eax,eax
	rep stosb
	popad

	call createmosauxskip
	mov ebp, linea
	call createmosaux
	mov ebp, arcup
	call createmosaux
	mov ebp, arcdown
	call createmosaux

	call createmosauxskip
	mov ebp,edx

;ebp   - dotfill ptr
;eax   - xres
;ebx   - yres
;esi   - descriptores de letras
;edi   - buffer temporal

    xor ecx,ecx           ;---ahora creamos la fuente---
    mov cl,[esi]
    inc esi
    push ecx

;[esp]  - bytes por letra
;[esp+4] - tabla offsets
;[esp+8] - buffer fuente
;[esp+12]- factor supersampling

lplettermos:
	cmp [esi],byte 255
	jz NEAR endcreatemos
	inc esi

	pushad     ;clear
	mov ecx,eax
	imul ecx,ebx
	xor eax,eax
	add edi,ecx
	rep stosb
	popad

	xor edx,edx
	mov ch,[esp]
lpbytemos:
		mov cl,8
lpbitmos:
		pushad
		dec cl
		mov ch,1
		shl ch,cl
		test [esi],ch
		jz nofill
		xor ecx,ecx
		mov cl,[ebp+edx*2]
		mov dl,[ebp+edx*2+1]
		and edx,255
		imul edx,ebx
		imul ecx,eax
		shr edx,8
		shr ecx,8
		mov esi,edi
		mov ebp,ebx
		imul ebp,eax
		add edi,ebp
		call floodfill          ;fill
nofill:
		popad
		inc edx
		dec cl
		jnz lpbitmos

	inc esi
	dec ch
	jnz lpbytemos

	pushad
	mov ecx,-1
	sub ecx,[esp+8*4]
	movzx ecx,byte [esi+ecx]
	shl ecx,2
	add ecx,[esp+4+8*4]
	mov edx,[esp+8+8*4]
	mov [ecx],edx
	mov edx,eax
	imul edx,ebx
	lea esi,[edi+edx]
	mov edi,[esp+8+8*4]
	mov ecx,[esp+12+8*4]
	pushad
	call downsample
	popad
	shr eax,cl
	shr ebx,cl
	imul eax,ebx
	add edi,eax
	mov [esp+8+8*4],edi
	popad

    jmp lplettermos
endcreatemos:
    add esp,4*4
    ret
